supports any combination of subversion, git, cvs, and bzr repositories,
and support for other revision control systems can easily be added.
-B<mr> cds into and operates on all registered repsitories at or below your
+B<mr> cds into and operates on all registered repositories at or below your
working directory. Or, if you are in a subdirectory of a repository that
contains no other registered repositories, it will stay in that directory,
and work on only that repository,
=item register
Register an existing repository in the mrconfig file. By default, the
-epository in the current directory is registered, or you can specify a
+repository in the current directory is registered, or you can specify a
directory to register.
+By default it registers it to the ~/.mrconfig file. To make it write to a
+different file, use the -c option.
+
=item config
Adds, modifies, removes, or prints a value from the mrconfig file. The next
Expand the statistics line displayed at the end to include information
about exactly which repositories failed and were skipped, if any.
+=item -n
+
+Just operate on the repository for the current directory, do not
+recurse into deeper repositories.
+
=back
=head1 FILES
directory, since the repository isn't checked out yet. All other commands
are run inside the repository, though not necessarily at the top of it.
The "MR_REPO" environment variable is set to the path to the top of the
-repository.
+repository, and "MR_CONFIG" is set to the topmost .mrconfig file used.
A few parameters have special meanings:
=item skip
-If the "skip" parameter is set and its command returns nonzero, then B<mr>
+If the "skip" parameter is set and its command returns true, then B<mr>
will skip acting on that repository. The command is passed the action
name in $1.
=item chain
-If the "chain" parameter is set and its command returns nonzero, then B<mr>
+If the "chain" parameter is set and its command returns true, then B<mr>
will try to load a .mrconfig file from the root of the repository. (You
should avoid chaining from repositories with untrusted committers.)
=item deleted
-If the "deleted" parameter is set and its command returns nonzero, then
+If the "deleted" parameter is set and its command returns true, then
B<mr> will treat the repository as deleted. It won't ever actually delete
-the repository, but it will warn if it sees the repsoitory's directory.
+the repository, but it will warn if it sees the repository's directory.
This is useful when one mrconfig file is shared amoung multiple machines,
to keep track of and remember to delete old repositories.
use Getopt::Long;
use Cwd qw(getcwd abs_path);
+$SIG{INT}=sub {
+ print STDERR "mr: interrupted\n";
+ exit 2;
+};
+
+$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
my $directory=getcwd();
-my $config="$ENV{HOME}/.mrconfig";
my $verbose=0;
my $stats=0;
+my $no_recurse=0;
my %config;
my %knownactions;
my %alias;
Getopt::Long::Configure("no_permute");
my $result=GetOptions(
"d|directory=s" => sub { $directory=abs_path($_[1]) },
- "c|config=s" => \$config,
+ "c|config=s" => sub { $ENV{MR_CONFIG}=abs_path($_[1]) },
"v|verbose" => \$verbose,
"s|stats" => \$stats,
+ "n|no-recurse" => \$no_recurse,
);
if (! $result || @ARGV < 1) {
die("Usage: mr [-d directory] action [params ...]\n".
}
loadconfig(\*DATA);
-loadconfig($config);
+loadconfig($ENV{MR_CONFIG});
#use Data::Dumper;
#print Dumper(\%config);
}
my $section=shift;
if ($section=~/^\//) {
- # try to convert to a path relative to $config's dir
- my ($dir)=$config=~/^(.*\/)[^\/]+$/;
+ # try to convert to a path relative to the config file
+ my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
if ($section=~/^\Q$dir\E(.*)/) {
$section=$1;
}
}
}
}
- modifyconfig($config, $section, %changefields) if %changefields;
+ modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
exit 0;
}
elsif ($action eq 'register') {
my $d=$directory;
$dir.="/" unless $dir=~/\/$/;
$d.="/" unless $d=~/\/$/;
- next if $dir ne $directory && $dir !~ /^\Q$directory\E/;
+ next if $no_recurse && $d ne $dir;
+ next if $dir ne $d && $dir !~ /^\Q$d\E/;
push @repos, [$dir, $topdir, $subdir];
}
}
my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
print "mr $action: running deleted test >>$test<<\n" if $verbose;
my $ret=system($test);
+ if ($ret != 0) {
+ if (($? & 127) == 2) {
+ print STDERR "mr $action: interrupted\n";
+ exit 2;
+ }
+ elsif ($? & 127) {
+ print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
+ }
+ }
if ($ret >> 8 == 0) {
print STDERR "mr error: $dir should be deleted yet still exists\n\n";
push @failed, $dir;
push @skipped, $dir;
return;
}
+
$dir=~s/^(.*)\/[^\/]+\/?$/$1/;
+
+ if (! -d $dir) {
+ print "mr $action: creating parent directory $dir\n" if $verbose;
+ my $ret=system("mkdir", "-p", $dir);
+ }
}
elsif ($action eq 'update') {
if (! -d $dir) {
"my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
print "mr $action: running skip test >>$test<<\n" if $verbose;
my $ret=system($test);
+ if ($ret != 0) {
+ if (($? & 127) == 2) {
+ print STDERR "mr $action: interrupted\n";
+ exit 2;
+ }
+ elsif ($? & 127) {
+ print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
+ exit 1;
+ }
+ }
if ($ret >> 8 == 0) {
print "mr $action: $dir skipped per config file\n" if $verbose;
push @skipped, $dir;
print STDERR "mr $action: running >>$command<<\n" if $verbose;
my $ret=system($command);
if ($ret != 0) {
+ if (($? & 127) == 2) {
+ print STDERR "mr $action: interrupted\n";
+ exit 2;
+ }
+ elsif ($? & 127) {
+ print STDERR "mr $action: received signal ".($? & 127)."\n";
+ }
print STDERR "mr $action: failed ($ret)\n" if $verbose;
push @failed, $dir;
if ($ret >> 8 != 0) {
print "mr $action: (skipped: ".join(" ", @skipped).")\n";
}
if (@failed) {
- print "mr $action: (failed: ".join(" ", @failed).")\n";
+ print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
}
}
if (@failed) {
$knownactions{$parameter}=1;
if ($parameter eq 'chain' &&
length $dir && $section ne "DEFAULT" &&
- -e $dir.$section."/.mrconfig" &&
- system($value) >> 8 == 0) {
- push @toload, $dir.$section."/.mrconfig";
+ -e $dir.$section."/.mrconfig") {
+ my $ret=system($value);
+ if ($ret != 0) {
+ if (($? & 127) == 2) {
+ print STDERR "mr $action: chain test interrupted\n";
+ exit 2;
+ }
+ elsif ($? & 127) {
+ print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
+ }
+ }
+ else {
+ push @toload, $dir.$section."/.mrconfig";
+ }
}
}
}
error "cannot determine svn url"
fi
echo "Registering svn url: $url"
- mr config "$(pwd)" checkout="svn co $url $basedir"
+ mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
elif [ -d .git ]; then
url=$(LANG=C git-config --get remote.origin.url)
if [ -z "$url" ]; then
error "cannot determine git url"
fi
echo "Registering git url: $url"
- mr config "$(pwd)" checkout="git clone $url $basedir"
+ mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
elif [ -d .bzr ]; then
url=$(cat .bzr/branch/parent)
if [ -z "$url" ]; then
error "cannot determine bzr url"
fi
echo "Registering bzr url: $url"
- mr config "$(pwd)" checkout="bzr clone $url $basedir"
+ mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
else
error "unable to register this repo type"
fi